from suds.client import Client
import base64
authURL = 'https://batches.gd-results.com/LogonService.svc?WSDL'
batchURL = 'https://batches.gd-results.com/Batches.svc?WSDL'


# you have to add the python library # sudo easy_install -z suds
# usage:
# python Download_GDML_Lab.py

user="YOUR_GMDL_USER"
pw="YOUR_GMDL_PASSWORD"


save_dir="/YOUR_LOCAL_DIRECTORY"


print "Logging into GDML Webservice ----  User lopun...",
authClient = Client(authURL)
logOnSuccess = authClient.service.Login(username=user,password=pw)

if logOnSuccess:
	print "Success!"
	batchClient = Client(batchURL)
	batchClient.options.transport.cookiejar	= authClient.options.transport.cookiejar
	batchFiles = batchClient.service.FetchAvailableBatchFiles()	
	try:
		print str(len(batchFiles.BatchInfo)) + " new file" + ("s" if len(batchFiles) != 1 else "") + " to download!"		
		for batchInfo in batchFiles.BatchInfo:
			try:
				print "Downloading " + str(batchInfo.BatchName) + "...",
				thisFile = batchClient.service.FetchBatchFile(batchInfo.Id)
				f = open(save_dir + "/" + str(batchInfo.BatchName), "w")
				f.write(thisFile)
				f.close()
				batchClient.service.AcknowledgeDownloadedBatchFile(batchInfo.Id, True)
				print "Success!"
			except IOError:
				print "Failed (IOError)."
				batchClient.service.AcknowledgeDownloadedBatchFile(batchInfo.Id, False)
			except:
				print "Failed (General Error)."
				batchClient.service.AcknowledgeDownloadedBatchFile(batchInfo.Id, False)
	except AttributeError:
		print "No new files."
else:
	print "Failed."

print "Logging off..."
authClient.service.Logout()